#respawn, with added delay to prevent minecraft jumping the gun
execute as @a[scores={death=10..,hp=1..}] at @s run function sprint_racer:game_logic/1/respawn
scoreboard players add @a[scores={death=1..}] death 1

#timer stuff
scoreboard players add @e[name=w] gameTime 1
execute unless entity @a[tag=playing,scores={playerState=2}] run scoreboard players remove @e[name=w,scores={timeRemaining=0..}] timeRemaining 1
function sprint_racer:game_logic/1/end_game_logic

#lap display (1-10 laps only)
execute if entity @e[tag=!hideLaps,name=w,scores={lap=1..10,gameTime=160..}] run function sprint_racer:game_logic/1/lap_bossbar/lap_bossbar_main

#delayed showing of a player's final results since they eat up a lot of the screen
scoreboard players remove @a[scores={lapShowDelay=1..}] lapShowDelay 1
execute as @a[tag=finished,scores={lapShowDelay=1}] at @s run function sprint_racer:game_logic/1/record_lap/show_final_results_delayed

#potion effect nodes
function sprint_racer:game_logic/1/node_effects/node_effects_main

#position calculator
execute if entity @e[name=w,tag=!moretick,scores={gameTime=100..,lap=..50}] unless entity @e[name=w,tag=ignoreCalc] run function sprint_racer:game_logic/1/position_calc/cycle_tick
execute if entity @e[name=w,tag=!moretick,tag=halftick,scores={gameTime=100..,lap=..50}] unless entity @e[name=w,tag=ignoreCalc] run function sprint_racer:game_logic/1/position_calc/cycle_tick
execute if entity @e[name=w,tag=moretick,scores={gameTime=160..,lap=..50}] unless entity @e[name=w,tag=ignoreCalc] run function sprint_racer:game_logic/1/position_calc/cycle_tick_fast_calc
execute unless entity @e[name=w,tag=ignoreCalc] if entity @e[name=w,scores={gameTime=200..,timeRemaining=1..}] run function sprint_racer:game_logic/1/position_calc/subtitle_display

#node loading stuff, staggered a bit for performance concerns
execute if entity @e[name=w,scores={gameTime=-20..40}] as @a[tag=playing,limit=1] at @s run scoreboard players set @e[limit=1,sort=nearest,tag=node,tag=activator,distance=..200] nodeState 5
scoreboard players add @e[name=w] nodeTimeCycle 1
scoreboard players set @e[name=w,scores={nodeTimeCycle=21..}] nodeTimeCycle 1
execute if entity @e[name=w,scores={nodeTimeCycle=1}] as @e[tag=node,tag=activator,scores={nodeState=1..}] at @s run scoreboard players set @e[tag=node,distance=..100] nodeState 1

#item stuff
execute if entity @e[name=w,tag=optItems,scores={oTimer=0,currentTimeMsec=0,gameTime=160..,timeRemaining=1..}] run function sprint_racer:game_logic/1/item_stuff
function sprint_racer:items/container_tick

#starting countdown
execute as @e[name=w,scores={gameTime=..240}] run function sprint_racer:game_logic/1/start_countdown

#global timer
execute as @e[name=w,scores={gameTime=160..,timeRemaining=0..}] run function sprint_racer:game_logic/1/global_timer
execute if entity @s[scores={oTimer=1,timeRemaining=0..}] run scoreboard players add @a[tag=playing,tag=!finished] currentTime 1

#actionbar display
execute if entity @e[name=w,scores={gameTime=100..}] run function sprint_racer_language:gameplay/actionbar_display_race

#lap animation
execute as @a[tag=playing,scores={lapAnimation=1..}] at @s run function sprint_racer:game_logic/1/lap_animation/index

#checkpoints and finish line
execute as @e[tag=checkpoint,tag=node,tag=!checkAnyY,scores={nodeState=1..}] at @s positioned ~-5 ~ ~-5 if entity @e[tag=activeplayer,dx=9,dy=9,dz=9] run function sprint_racer:game_logic/1/checkpoint_operate
execute as @e[tag=checkpoint,tag=node,tag=checkAnyY,scores={nodeState=1..}] at @s positioned ~-5 0 ~-5 if entity @e[tag=activeplayer,dx=9,dy=300,dz=9] run function sprint_racer:game_logic/1/checkpoint_operate_any_y
execute as @e[tag=finishline,tag=node,tag=!finAnyY,scores={nodeState=1..}] at @s positioned ~-5 ~ ~-5 if entity @e[tag=activeplayer,dx=9,dy=9,dz=9] run function sprint_racer:game_logic/1/finishline_operate
execute as @e[tag=finishline,tag=node,tag=finAnyY,scores={nodeState=1..}] at @s positioned ~-5 0 ~-5 if entity @e[tag=activeplayer,dx=9,dy=300,dz=9] run function sprint_racer:game_logic/1/finishline_operate_any_y
execute as @a[tag=checkIncrement] at @s run function sprint_racer:game_logic/1/increment_checkpoint
execute as @e[tag=ai,tag=checkIncrement] at @s run function sprint_racer:game_logic/1/increment_checkpoint_ai
execute as @a[tag=finishLap] at @s run function sprint_racer:game_logic/1/finish_lap
execute as @e[tag=ai,tag=finishLap] at @s run function sprint_racer:game_logic/1/finish_lap_ai
execute if entity @e[name=w,scores={gameTime=160..}] run scoreboard players add @a[tag=playing,gamemode=adventure] timeSinceCheck 1
execute if entity @e[name=w,scores={gameTime=160..}] run scoreboard players add @e[tag=AImaster] timeSinceCheck 1

#navigation stuff part 1
scoreboard players set @a[tag=playing,gamemode=!spectator] recDirection 0
function sprint_racer:game_logic/1/nav/_index

#track-specific logic
execute as @e[tag=chosenTrack,scores={rNumber=..8}] run function sprint_racer:levels/_index_levels_race_novice
execute as @e[tag=chosenTrack,scores={rNumber=9..14}] run function sprint_racer:levels/_index_levels_race_intermediate
execute as @e[tag=chosenTrack,scores={rNumber=15..}] run function sprint_racer:levels/_index_levels_race_expert_master

#navigation stuff part 2
execute as @a[tag=!noInventory,tag=playing,gamemode=adventure] run function sprint_racer:game_logic/1/nav/main_logic
execute as @e[type=ender_pearl] at @s if block ~ 0 ~ black_wool run kill @s
scoreboard players add @a[scores={recDirection=10,offCourseBuffer=..23}] offCourseBuffer 2
scoreboard players add @a[scores={navDirection=3..5,wrongWayBuffer=..23}] wrongWayBuffer 2
scoreboard players remove @a[scores={offCourseBuffer=1..}] offCourseBuffer 1
scoreboard players remove @a[scores={wrongWayBuffer=1..}] wrongWayBuffer 1

#repeat a few functions in half tick speed mode is enabled
execute if entity @e[name=w,tag=halftick,scores={gameState=1}] run function sprint_racer:game_logic/1/gl1_main_echo

#keep spectators from flying away
execute if entity @e[name=w,scores={gameTime=100..}] as @a[gamemode=spectator] at @s unless entity @e[tag=activator,distance=..120,scores={nodeState=1..}] run function sprint_racer:spectators_keep_in_bounds

#reset
scoreboard players remove @a[scores={resetCooldown=1..}] resetCooldown 1
execute as @a[scores={carrotInput=..999,inputCooldown=..0},nbt={SelectedItem:{tag:{Tags:["reset"]}}}] at @s run function sprint_racer:game_logic/1/reset/player_use_reset

#give reset item
tag @a[tag=hasReset] remove hasReset
tag @a[gamemode=!creative,tag=playing,nbt={Inventory:[{Slot:8b,id:"minecraft:barrier",tag:{Tags:["reset"]}}]}] add hasReset
clear @a[gamemode=!creative,tag=!hasReset] barrier
execute as @a[gamemode=!creative,tag=!hasReset,tag=!noInventory] run function sprint_racer_language:give_barrier